//
// File format detector
//
#include <stdio.h>
#include "FileFormat.h"



int DetectFormat(char *filename)
{
	FILE *fr;
	char buff[3];

	if((fr = fopen(filename, "r")) == NULL)
		return FFORMAT_UNKNOWN;

	fread(buff, sizeof(buff), 1, fr);

	if(buff[0] == 'B' && buff[1] == 'M') {
		fclose(fr);
		return FFORMAT_BMP;
	}

	if(buff[0] == 0x0a && (buff[1] == 0 || buff[1] == 2 || buff[1] == 3 || buff[1] == 5)) {
		fclose(fr);
		return FFORMAT_PCX;
	}

	if(buff[0] == 'G' && buff[1] == 'I' && buff[2] == 'F') {
		fclose(fr);
		return FFORMAT_GIF;
	}

	/*/ Image type:
	 *    0 = no image data
	 *    1 = uncompressed color mapped
	 *    2 = uncompressed true color
	 *    3 = grayscale
	 *    9 = RLE color mapped
	 *   10 = RLE true color
	 *   11 = RLE grayscale
	/*/
	if(buff[2] == 1 || buff[2] == 2 || buff[2] == 3 ||
	   buff[2] == 9 || buff[2] == 10 || buff[2] == 11) {
		fclose(fr);
		return FFORMAT_TGA;
	}

	fclose(fr);

	return FFORMAT_UNKNOWN;
}