
// 32-bit bitmap loader

#include <stdio.h>
#include <windows.h>
#include <stdlib.h>
#include "True_Bmp.h"

BMP *Load_True_ColorBMP(char *path)
{
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	BYTE *lpbBuf;
	int BuffLen;
	FILE *BMPfp;
	BMP *tmp;
	int	i, j;
	
	if((BMPfp = fopen(path, "rb")) == NULL)
		return NULL;
	// open file

	fread(&bmfh, sizeof(bmfh), 1, BMPfp);
	fread(&bmih, sizeof(bmih), 1, BMPfp);
	// read headers

	if(bmfh.bfType != ('B'|('M'<<8)))
		return NULL; 
	// check format is 'BM'

	if(bmih.biBitCount == 24 && bmih.biCompression == BI_RGB) {
		if((tmp = (BMP*) malloc(sizeof(BMP))) == NULL)
			return NULL;
		// alloc memory
		tmp->width = bmih.biWidth;
		tmp->height = bmih.biHeight;
		if((tmp->bytes = (unsigned __int32*) malloc(
			bmih.biWidth * bmih.biHeight * 4)) == NULL) return NULL;
		// prepare bitmap structure

		BuffLen = ((bmih.biWidth * 3 + 3) >> 2) << 2;
		// scanline aligned to 32bits

		if((lpbBuf = (BYTE*)malloc(BuffLen * sizeof(BYTE))) == NULL)
			return NULL;
		// alloc memory for scanline buffer

		for(i = bmih.biHeight - 1; i >= 0; i --) {
			if((j = fread(lpbBuf, sizeof(char), BuffLen, BMPfp)) != BuffLen)
				return NULL;
			// read scanline

			for(j = 0; j < (signed)bmih.biWidth; j ++) {
				tmp->bytes[j + bmih.biWidth * i] = RGB(lpbBuf[j * 3 + 2],
					lpbBuf[j * 3 + 1], lpbBuf[j * 3]);
			}
			// copy scanline to bitmap structure
		}
	} else
		return NULL;

	free(lpbBuf);
	// free memory used for reading scanline

	return tmp;
}